package sftp;

sub transfer (\%\%){
	my ($record) = $_[1];		# not sure why but $_[0] eq "sftp"
	my ($directive) = $_[2];
	%record=%{$record};
	%directive = %{$directive};	

	$record{"args"} .= '-o "PasswordAuthentication no"'; #suppress passwd


	$script = "lcd " . $directive{"local_root"} . "/" . 
		$record{"local_dir"} . "\ncd " . $record{"remote_dir"} . "\n";

	if ($record{"mode"} == 0 || $record{"mode"} == 1){
		$script .= "get * \n";
	}

	elsif ($record{"mode"} == 2) {
		$script .= "put * \n";
	}

	else {
		print {STDERR} "Error in transport 'sftp' for host ";
		print {STDERR} $record{"host"} . ": Unrecognized mode.\n";
		return false;
	}

	if ($row{"mode"} == 0){
		$script .= "rm *\n";
	}
	$script .= "exit \n";
	@options = split /,/, $record{"options"};
	foreach $option (@options){
		@elements = split /=/, $option, 2;
		if ($elements[0] eq "IdentityFile"){
			$record{"args"} .= " -o \"" . $elements[0] . " " . 
				$elements[1] . "\"";
			$record{"subvars"}{"key_filed"}=1;
		}
		
		elsif ($elements[0] eq "user"){
			$record{"subvars"}{"user"} = $elements[1] . '@';
		}
		elsif ($elements[0] eq "config"){
			$record{"args"} .= " -F " . $elements[1];
		}

		else {
			$record{"args"} .= " -o \"" . $elements[0] . " " . 
				$elements[1] . "\"";
		}
	}

	if (!$record{"sub_vars"}{"key_filled"}){
		if ($directive{"ssh_key"}){
			if ($directive{"ssh_key"} ne "IMPLICIT"){
				$record{"args"} .= " -o \"IdentityFile " . 
					$directive{"ssh_key"} . "\"";
			}
		}
		else {
			print {STDERR} "Error in transport 'sftp' for host ";
			print {STDERR} $record{"host"} . ": No Key Specified\n";
			return false;
		}
	
	}
	if (!$record{"subvars"}{"user"}){
		if ($directive{"ssh_user"}){
			if ($directive{"ssh_user"} ne "IMPLICIT"){
				$record{"subvars"}{"user"} = 
					$directive{"ssh_user"} . '@';
			}
		}
		else {
			print {STDERR} "Error in transport 'sftp' for host ";
			print {STDERR} $record{"host"} . ": No user ";
			print {STDERR} "specified\n";
			return false;
		}
	}

	$record{"args"} .= " " . $record{"subvars"}{"user"} . $record{"host"};
	$args=$record{"args"};
	$script = "echo \"$script\" | sftp " . $record{"args"}; 
	`$script`;
}







